package hr.model.businessdomain;
import oracle.jbo.server.rules.JbiValidator;
import oracle.jbo.server.util.VetoableChangeListener;
import oracle.jbo.server.util.PropertyChangeEvent;
import oracle.jbo.ValidationException;

public class MaxLengthValidator implements JbiValidator 
{
  private String description;
  private int maxLength;

  public MaxLengthValidator()
  {
  }

  /**
   * 
   *  Return true if value is valid
   * @param value
   * @return 
   */
  public boolean validateValue(Object value)
  {
    boolean returnVal;
    if (value.toString().length() <= getMaxLength())
    {
      returnVal = true;
    }
    else
    {
      returnVal = false;
    }
    return returnVal;
  }

  /**
   * 
   *  Invoked by framework for validation
   * @param eventObj
   */
  public void vetoableChange(PropertyChangeEvent eventObj)
  {
    if (!validateValue(eventObj.getNewValue()))
    {
      throw new ValidationException(getDescription());
    }
  }

  /**
   * 
   *  Description of what this class validates
   * @return 
   */
  public String getDescription()
  {
    return description;
  }

  /**
   * 
   *  Description of what this class validates
   * @param str
   */
  public void setDescription(String str)
  {
    description = str;
  }

  public int getMaxLength()
  {
    return maxLength;
  }

  public void setMaxLength(int maxLength)
  {
    this.maxLength = maxLength;
  }
}