package layout.client;
import javax.swing.JFrame;
import java.awt.Dimension;
import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.BorderFactory;
import javax.swing.border.EtchedBorder;
import javax.swing.border.BevelBorder;

public class BorderLayoutFrame extends JFrame 
{
  private BorderLayout borderLayout1 = new BorderLayout();
  private JPanel mainPanel = new JPanel();
  private BorderLayout borderLayout2 = new BorderLayout();
  private JPanel northPanel = new JPanel();
  private JPanel southPanel = new JPanel();
  private JPanel westPanel = new JPanel();
  private JPanel eastPanel = new JPanel();
  private JPanel centerPanel = new JPanel();

  public BorderLayoutFrame()
  {
    try
    {
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }

  }

  private void jbInit() throws Exception
  {
    this.getContentPane().setLayout(borderLayout1);
    this.setSize(new Dimension(400, 300));
    this.setTitle("BorderLayout");
    mainPanel.setLayout(borderLayout2);
    borderLayout2.setHgap(5);
    borderLayout2.setVgap(5);
    northPanel.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));
    northPanel.setPreferredSize(new Dimension(14, 50));
    southPanel.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
    southPanel.setPreferredSize(new Dimension(14, 50));
    westPanel.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
    westPanel.setPreferredSize(new Dimension(50, 14));
    eastPanel.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
    eastPanel.setPreferredSize(new Dimension(50, 14));
    centerPanel.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
    mainPanel.add(northPanel, BorderLayout.NORTH);
    mainPanel.add(southPanel, BorderLayout.SOUTH);
    mainPanel.add(westPanel, BorderLayout.WEST);
    mainPanel.add(eastPanel, BorderLayout.EAST);
    mainPanel.add(centerPanel, BorderLayout.CENTER);
    this.getContentPane().add(mainPanel, BorderLayout.CENTER);
  }
}